package com.xhkjedu.sapi.controller.appversion;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.xhkjedu.annotation.Action;
import com.xhkjedu.sapi.model.appversion.TAppLive;
import com.xhkjedu.sapi.service.appversion.AppLiveService;
import com.xhkjedu.sapi.vo.appversion.AppversionVo;
import com.xhkjedu.utils.N_Utils;
import com.xhkjedu.utils.PageUtil;
import com.xhkjedu.vo.PageResult;
import com.xhkjedu.vo.ResultVo;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/*
* @Description 直播端（教师+学生）
* @Author WN
* @Date 2023/7/6 10:46:45
*/
@RestController
@RequestMapping("/applive")
public class AppLiveController {
    @Resource
    private AppLiveService appLiveService;

    @PostMapping("/add")
    @Action("直播端-增加")
    public ResultVo add(@RequestBody TAppLive appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionname(),"版本名称",2,
                appclient.getVersioncode(),"版本号",2,appclient.getVersionpath(),"应用文件",2});
        Integer id = appLiveService.save(appclient);
        return new ResultVo(0, "保存成功",id);
    }

    @PostMapping("/delete")
    @Action("直播端-删除")
    public ResultVo delete(@RequestBody TAppLive appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionid(),"版本id",1});
        appLiveService.deleteById(appclient.getVersionid());
        return new ResultVo(0,"删除成功");
    }

    @PostMapping("/update")
    @Action("直播端-修改")
    public ResultVo update(@RequestBody TAppLive appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionid(),"版本id",1});
        appLiveService.update(appclient);
        return new ResultVo(0,"修改成功");
    }

    @PostMapping("/detail")
    public ResultVo detail(@RequestBody TAppLive appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionid(),"版本id",1});
        TAppLive client = appLiveService.findById(appclient.getVersionid());
        return new ResultVo(0,"获取详情成功",client);
    }

    @PostMapping("/list")
    public ResultVo list(@RequestBody TAppLive appclient) {
        PageHelper.startPage(appclient.getPage(), appclient.getPageSize());
        List<AppversionVo> list = appLiveService.listAll();
        PageResult pageResult = PageUtil.getPageResult(new PageInfo(list));
        return new ResultVo(0,"获取app版本列表成功",pageResult);
    }

    @PostMapping("/get_new")
    public ResultVo getNew() {
        TAppLive appclient = appLiveService.getNew();
        return new ResultVo(0,"获取最新app版本成功",appclient);
    }
}
